"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var archiver = require("archiver");
var fs = require("fs");
var ncp = require('ncp').ncp; // shell cp says "cp: omitting directory 'C:/Users/stephen/AppData/Local/Temp/task-FR6WUc/task-after-sign'"
var os = require("os");
var path = require("path");
var shell = require("shelljs");
var tasksBase = require("./default");
var trace = require("../../../lib/trace");
function getCommand(args) {
    return new BuildTaskSign(args);
}
exports.getCommand = getCommand;
var BuildTaskSign = /** @class */ (function (_super) {
    __extends(BuildTaskSign, _super);
    function BuildTaskSign(args) {
        var _this = _super.call(this, args) || this;
        _this.description = "Sign a task.";
        _this.serverCommand = true;
        return _this;
    }
    BuildTaskSign.prototype.getHelpArgs = function () {
        return ["certFingerprint", "taskPath", "newGuid", "newNameSuffix"];
    };
    // tfx build tasks sign --task-path {TASK_PATH} --cert-fingerprint {FINGERPRINT} --new-guid {GUID} --new-name-suffix 'SIGNED'
    // tfx build tasks sign --task-path "D:\customtask" --cert-fingerprint 6E45D9EEE6227589D9AD56D3F29C096F84153284 --new-guid F256057D-52CB-4E38-8974-BCD36D618834 --new-name-suffix 'SIGNED'
    // node tfx-cli.js build tasks sign --task-path "D:\customtask" --cert-fingerprint 6E45D9EEE6227589D9AD56D3F29C096F84153284 --new-guid F256057D-52CB-4E38-8974-BCD36D618834 --new-name-suffix 'SIGNED'
    // --new-guid and --new-name-suffix are optional
    BuildTaskSign.prototype.exec = function () {
        return __awaiter(this, void 0, void 0, function () {
            var taskZipsPath, taskZipPath, certFingerprint, newGuid, newNameSuffix, nuGetPath, tempFolder, taskTempFolder, taskTempZipPath, taskTempNupkgPath, needToUpdateTaskJson, taskJsonPath, taskLocJsonPath, resourcesPath, data, taskJson, nuspecPath, command, execResult, result_1, collectionUrl, agentApi, overwrite, archive, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.commandArgs.taskPath.val()];
                    case 1:
                        taskZipsPath = _a.sent();
                        taskZipPath = taskZipsPath[0];
                        return [4 /*yield*/, this.commandArgs.certFingerprint.val()];
                    case 2:
                        certFingerprint = _a.sent();
                        return [4 /*yield*/, this.commandArgs.newGuid.val()];
                    case 3:
                        newGuid = _a.sent();
                        return [4 /*yield*/, this.commandArgs.newNameSuffix.val()];
                    case 4:
                        newNameSuffix = _a.sent();
                        nuGetPath = shell.which("nuget");
                        if (!nuGetPath) {
                            throw new Error("Unable to find NuGet. Please add NuGet to the PATH before continuing.");
                        }
                        tempFolder = fs.mkdtempSync(path.join(os.tmpdir(), "task-"));
                        trace.info("temp folder: " + tempFolder);
                        taskTempFolder = path.join(tempFolder, "task");
                        taskTempZipPath = path.join(tempFolder, "task.zip");
                        taskTempNupkgPath = path.join(tempFolder, "task.nupkg");
                        // Create temp folder
                        fs.mkdirSync(taskTempFolder);
                        // Copy task contents to temp folder
                        shell.cp("-R", taskZipPath, taskTempFolder);
                        // Task temp folder is now task\PREVIOUS_NAME
                        taskTempFolder = path.join(taskTempFolder, path.basename(taskZipPath));
                        needToUpdateTaskJson = !!newGuid || !!newNameSuffix;
                        if (needToUpdateTaskJson) {
                            taskJsonPath = path.join(taskTempFolder, "task.json");
                            taskLocJsonPath = path.join(taskTempFolder, "task.loc.json");
                            if (fs.existsSync(taskJsonPath)) {
                                this.updateTaskMetadata(taskJsonPath, newGuid, newNameSuffix);
                            }
                            if (fs.existsSync(taskLocJsonPath)) {
                                this.updateTaskMetadata(taskLocJsonPath, newGuid, newNameSuffix);
                            }
                            resourcesPath = path.join(taskTempFolder, "Strings", "resources.resjson", "en-US", "resources.resjson");
                            if (fs.existsSync(resourcesPath)) {
                                trace.info("resources file exists, modifying");
                                data = fs.readFileSync(resourcesPath, "utf8");
                                taskJson = JSON.parse(data);
                                taskJson["loc.friendlyName"] = taskJson["loc.friendlyName"] + " " + newNameSuffix.replace(/'/g, "");
                                fs.writeFileSync(resourcesPath, JSON.stringify(taskJson, null, 4));
                            }
                            // TODO: Do we need to change friendlyName in Strings\resources.resjson\en-US\resources.resjson?
                            // Does localization run for tfx installed tasks?
                        }
                        // Write nuspec file
                        trace.info("writing nuspec file");
                        nuspecPath = path.join(taskTempFolder, ".nuspec");
                        this.writeNuspecFile(nuspecPath, certFingerprint);
                        // Zip
                        return [4 /*yield*/, this.zipDirectory(taskTempFolder, taskTempZipPath)];
                    case 5:
                        // Zip
                        _a.sent();
                        // Rename to nupkg
                        fs.renameSync(taskTempZipPath, taskTempNupkgPath);
                        command = "\"" + nuGetPath + "\" sign " + taskTempNupkgPath + " -CertificateFingerprint " + certFingerprint + " -NonInteractive";
                        trace.info("Executing command: '" + command + "'");
                        execResult = shell.exec(command, { silent: true });
                        if (execResult.code === 1) {
                            trace.info(execResult.output);
                            //await del(tempFolder, { force: true });
                            shell.rm('-rf', tempFolder);
                            result_1 = { signingSuccessful: false };
                            return [2 /*return*/, result_1];
                        }
                        // Rename .nupkg back to to .zip
                        fs.renameSync(taskTempNupkgPath, taskTempZipPath);
                        // Extract into new temp task folder
                        // const taskAfterSignTempFolder: string = path.join(
                        //   tempFolder,
                        //   "task-after-sign"
                        // );
                        // fs.mkdirSync(taskAfterSignTempFolder);
                        // const zip = new admZip(taskTempZipPath);
                        // zip.extractAllTo(taskAfterSignTempFolder);
                        //await extractZip(taskTempZipPath, taskAfterSignTempFolder);
                        // Copy task contents
                        // This can include the new signature file as well as a modified task.json
                        // trace.info("copying task contents");
                        // await this.ncpAsync(taskAfterSignTempFolder, taskZipPath);
                        //shell.cp('-r', taskAfterSignTempFolder, taskZipPath)
                        // await this.ensureInitialized();
                        trace.info("done running ensure initialized");
                        collectionUrl = this.connection.getCollectionUrl();
                        console.log("Collection URL: " + collectionUrl);
                        return [4 /*yield*/, this.webApi.getTaskAgentApi(collectionUrl)];
                    case 6:
                        agentApi = _a.sent();
                        overwrite = false;
                        trace.info("creating read stream");
                        archive = fs.createReadStream(taskTempZipPath);
                        fs.copyFileSync(taskTempZipPath, 'E:\\foo.zip');
                        trace.info("uploading task definition");
                        return [4 /*yield*/, agentApi.uploadTaskDefinition(null, archive, newGuid, overwrite)];
                    case 7:
                        _a.sent(); // TODO: Handle where the GUID isn't passed and we use existing task id.
                        // Delete temp folder
                        trace.info("deleting temp folder");
                        //await del(tempFolder, { force: true });
                        //shell.rm('-rf', tempFolder);
                        trace.info("temp folder: " + tempFolder); // TODO: Remove this, uncomment line above.
                        // causes ENOTEMPTY a lot on Windows
                        trace.info("done deleting temp folder");
                        result = { signingSuccessful: true };
                        return [2 /*return*/, result];
                }
            });
        });
    };
    BuildTaskSign.prototype.friendlyOutput = function (data) {
        trace.println();
        if (data.signingSuccessful) {
            trace.success("Task signed successfully!");
        }
        else {
            trace.error("Task signing failed.");
        }
    };
    // Update name and name suffix for task metadata
    // This file can be either task.json or task.loc.json
    BuildTaskSign.prototype.updateTaskMetadata = function (path, newGuid, newNameSuffix) {
        var data = fs.readFileSync(path, "utf8");
        var taskJson = JSON.parse(data);
        if (newGuid) {
            taskJson.id = newGuid;
        }
        if (newNameSuffix) { // dont replace for loc for now, see if it works. Maybe we just replace id for loc?
            // "loc.friendlyName": "Use Node.js ecosystem",
            // 
            taskJson.name = "" + taskJson.name + newNameSuffix.replace(/'/g, ""); // updating the name for use in yaml
            // Don't update if it's a loc string.
            // Maybe we need to update the en-us string?
            if (taskJson.friendlyName.indexOf("loc.") === -1) {
                // update friendly name if this isn't a loc file
                // this is what user created tasks have
                taskJson.friendlyName = taskJson.friendlyName + " " + newNameSuffix.replace(/'/g, ""); // updating friendly name for use in the ui
            }
            else {
                // if there is a loc file, we want to modify the localization file instead
            }
        }
        fs.writeFileSync(path, JSON.stringify(taskJson, null, 4));
    };
    // Wrap ncp in Promise so we can async it
    // private ncpAsync(src: string, dest: string): Promise<void> {
    //   return new Promise(function(resolve, reject) {
    //     ncp(src, dest, function(err) {
    //       if (err) {
    //         reject(err);
    //       }
    //       resolve();
    //     });
    //   });
    // }
    // Write nuspec file into contents of task
    // This allows nuget to verify the signature of the package
    // We also use this file to store what cert was used to sign the package
    BuildTaskSign.prototype.writeNuspecFile = function (nuspecFilePath, certFingerprint) {
        var contents = '';
        contents += "<?xml version=\"1.0\" encoding=\"utf-8\"?>" + os.EOL;
        contents += "<package xmlns=\"http://schemas.microsoft.com/packaging/2010/07/nuspec.xsd\">" + os.EOL;
        contents += "    <metadata>" + os.EOL;
        contents += "        <!-- Required elements-->" + os.EOL;
        contents += "        <id>Task</id>" + os.EOL;
        contents += "        <version>0.0.0</version>" + os.EOL;
        contents += "        <description>This is used for signing only.</description>" + os.EOL;
        contents += "        <authors>This is used for signing only.</authors>" + os.EOL;
        contents += "" + os.EOL;
        contents += "        <!-- Optional elements -->" + os.EOL;
        //contents += `        <certificateFingerprint>${certFingerprint}</certificateFingerprint>${os.EOL}`; // TODO: When we sign I think we need to pass the sha256, that is what needs to be stored here as that's what we use to verify. Not the thumbprint.
        // TODO: Can we drop this and use verify and pass in multiple fingerprints to do validation instead? Test that.
        contents += "        <certificateFingerprint>F25A1708C41B49011641458B2108F230F0B968484E329ED6018BD5E8A279AABD</certificateFingerprint>" + os.EOL; // TODO: When we sign I think we need to pass the sha256, that is what needs to be stored here as that's what we use to verify. Not the thumbprint.
        contents += "    </metadata>" + os.EOL;
        contents += "    <!-- Optional 'files' node -->" + os.EOL;
        contents += "</package>";
        fs.writeFileSync(nuspecFilePath, contents);
    };
    // Helper function to zip a directory
    BuildTaskSign.prototype.zipDirectory = function (source, out) {
        var archive = archiver("zip", { zlib: { level: 9 } });
        var stream = fs.createWriteStream(out);
        return new Promise(function (resolve, reject) {
            archive
                .directory(source, false)
                .on("error", function (err) { return reject(err); })
                .pipe(stream);
            stream.on("close", function () { return resolve(); });
            archive.finalize();
        });
    };
    return BuildTaskSign;
}(tasksBase.BuildTaskBase));
exports.BuildTaskSign = BuildTaskSign;
//# sourceMappingURL=sign.js.map