"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var jszip = require("jszip");
var path = require("path");
var trace = require("./trace");
var mkdirp = require("mkdirp");
/**
 * Extract the contents of a zip file.
 */
function extractZip(zipPath, destinationPath) {
    var _this = this;
    return new Promise(function (resolve, reject) {
        fs.readFile(zipPath, function (err, data) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!err) return [3 /*break*/, 1];
                        reject(err);
                        return [3 /*break*/, 3];
                    case 1: return [4 /*yield*/, jszip.loadAsync(data).then(function (zip) { return __awaiter(_this, void 0, void 0, function () {
                            var _loop_1, _i, _a, fileName;
                            var _this = this;
                            return __generator(this, function (_b) {
                                switch (_b.label) {
                                    case 0:
                                        _loop_1 = function (fileName) {
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0:
                                                        trace.debug("Save file " + fileName);
                                                        return [4 /*yield*/, zip.files[fileName].async("nodebuffer").then(function (buffer) { return __awaiter(_this, void 0, void 0, function () {
                                                                var noLeadingFolderFileName, fullPath;
                                                                return __generator(this, function (_a) {
                                                                    switch (_a.label) {
                                                                        case 0:
                                                                            trace.debug("Writing buffer for " + fileName);
                                                                            noLeadingFolderFileName = fileName.substr(fileName.indexOf("/"));
                                                                            fullPath = path.join(destinationPath, noLeadingFolderFileName);
                                                                            if (fullPath.endsWith("\\")) {
                                                                                // don't need to "write" the folders since they are handled by createFolderIfNotExists().
                                                                                return [2 /*return*/];
                                                                            }
                                                                            trace.debug("Creating folder if it doesn't exist: " + path.dirname(fullPath));
                                                                            return [4 /*yield*/, createFolderIfNotExists(path.dirname(fullPath))];
                                                                        case 1:
                                                                            _a.sent();
                                                                            fs.writeFile(fullPath, buffer, function (err) {
                                                                                if (err) {
                                                                                    console.log("err: " + err);
                                                                                    reject(err);
                                                                                }
                                                                            });
                                                                            return [2 /*return*/];
                                                                    }
                                                                });
                                                            }); })];
                                                    case 1:
                                                        _a.sent();
                                                        return [2 /*return*/];
                                                }
                                            });
                                        };
                                        _i = 0, _a = Object.keys(zip.files);
                                        _b.label = 1;
                                    case 1:
                                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                                        fileName = _a[_i];
                                        return [5 /*yield**/, _loop_1(fileName)];
                                    case 2:
                                        _b.sent();
                                        _b.label = 3;
                                    case 3:
                                        _i++;
                                        return [3 /*break*/, 1];
                                    case 4: return [2 /*return*/];
                                }
                            });
                        }); })];
                    case 2:
                        _a.sent();
                        resolve();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        }); });
    });
}
exports.extractZip = extractZip;
// TODO: Move to fsUtils
function createFolderIfNotExists(folderPath) {
    return __awaiter(this, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, new Promise(function (resolve, reject) {
                            mkdirp(folderPath, function (err) {
                                if (err) {
                                    reject(err);
                                }
                                else {
                                    resolve();
                                }
                            });
                        })];
                case 1:
                    _b.sent();
                    return [3 /*break*/, 3];
                case 2:
                    _a = _b.sent();
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=zipUtils.js.map